//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "pagewidth.h"
#include "paragraph.h"
#include "Main.h"
#include "ejecuta.h"
#include "traduce.h"
#include "construye.h"

#include <process.h>
#include <stdlib.h>
#include <time.h>
#include "com.h"
#include "editor.h"
#include "pcom1.h"
#include "pcom2.h"
#include "Compile.h"
#include "EditorUE.h"
#include "Generator.h"
#include "comAB.h"
#include "uplanlia.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;

//---------------------------------------------------------------------------
char NomArch[250] ;

#include "LIAtiempo.h"
#include "LIAtiempo.c"


//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
  pagewidth = 6.5 ;
  return ;
}
//----------------------------------------------------------------------------
void __fastcall TMainForm::PrintSetup1Click(TObject *Sender)
{
  PrinterSetupDialog1->Execute () ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::Print1Click(TObject *Sender)
{
  if (PrintDialog1->Execute ())
    RichEdit1->Print("");    
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
  Close () ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::New1Click(TObject *Sender)
{
  NewFile () ;
  return ;
}
//---------------------------------------------------------------------
bool TMainForm::SaveFile ()
{
  // This function saves the file. It returns true if the user cancels.

  // If there is no file name then get one from the user.
  if (filename == "")
  {
    return SaveFileAs () ;
  }
  else
  {
    RichEdit1->Lines->SaveToFile (filename) ;
    return false ;
  }
}

bool TMainForm::SaveFileAs ()
{
  // This function lets the user enter a file name the save the edit window to
  // this file.  It returns true if the user cancels.
  if (! SaveDialog1->Execute ())
    return true ; // User clicked on cancel.

  filename = SaveDialog1->FileName ;
  // If the file name indicates Rich Text then save the formatting infomration.
  // otherwise save as text.
  if (filename.SubString (filename.Length () - 3, 4).UpperCase () == ".RTF")
    RichEdit1->PlainText = false ;
  else
    RichEdit1->PlainText = true ;

  UpdateStatusBar () ;
  SaveFile () ;
  return false ;
}

bool TMainForm::NewFile ()
{
  // This function resets the edit window. It returns true if the user indicates
  // does not want to discard changes made.

  // If the user has changed the text the give him a change to save it.
  if (RichEdit1->Modified)
  {
    switch (Application->MessageBox ("Do you wish to save your changes?",
                                     "Word Processor",
                                     MB_YESNOCANCEL))
    {
    case IDYES:
      if (SaveFile ())
        return true ;
      break ;
    case IDCANCEL:
      return true ;
    }
  }
  // Clear out the edit window and update the file names.
  RichEdit1->Text = "" ;
  RichEdit1->Modified = false ;
  filename = "" ;
  UpdateStatusBar () ;
  return false ;
}

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  NewFile () ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::SaveAs1Click(TObject *Sender)
{
  SaveFileAs () ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::Save1Click(TObject *Sender)
{
  SaveFile () ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::Open1Click(TObject *Sender)
{
  if (NewFile ())
    return ;

  if (OpenDialog1->Execute())
  { // User clicked on OK.
    String file = OpenDialog1->FileName ;
    // See if the user selected a Rich Text File. If so then treat the
    // contents a formatted text.
    MainForm->Caption = AnsiString("LIA - ") + file;
    strcpy(NomArch ,file.c_str());
    if (file.SubString (file.Length () - 3, 4).UpperCase () == ".RTF")
      RichEdit1->PlainText = false ;
    else
      RichEdit1->PlainText = true ;
    RichEdit1->Lines->LoadFromFile (file) ;
    RichEdit1->Modified = false ;
    filename = file ;
    UpdateStatusBar () ;
  }
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::SpeedButton1Click(TObject *Sender)
{
  SaveFile () ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::SpeedButton2Click(TObject *Sender)
{
  RichEdit1->Print ("") ;
  return ;
}
//---------------------------------------------------------------------
void __fastcall TMainForm::Find1Click(TObject *Sender)
{
  FindDialog1->Execute () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FindDialog1Find(TObject *Sender)
{
  TFindDialog *dialog = (TFindDialog *)(Sender) ;

  int position ;  // Position the string is found

  // Copy the search options from the dialog box.
  TSearchTypes options ;
  if (dialog->Options.Contains (frMatchCase))
    options << stMatchCase ;
  if (dialog->Options.Contains (frWholeWord))
    options << stWholeWord ;

  lastsearchstring = dialog->FindText ;
  // See if we are searching up or down.
  if (dialog->Options.Contains (frDown))
  {
    // Searching down is easy.
    int start = RichEdit1->SelStart ;
    if (RichEdit1->SelLength != 0)  // This allows cursor position to be matched.
      ++ start ;
    position = RichEdit1->FindText (dialog->FindText,
                                    start,
                                    RichEdit1->Text.Length () - RichEdit1->SelStart-1,
                                    options) ;
  }
  else if (RichEdit1->SelStart > 0)
  {
    // For searching down we have to loop until we find the previous match.
    int search = -1 ;
    do
    {
      position = search ;
      search = RichEdit1->FindText (dialog->FindText,
                                    search + 1,
                                    RichEdit1->SelStart - search - 1,
                                    options) ;

    } while (search >= 0) ;
  }
  else
  {
    // We are searching up from the start of the buffer.
    position = -1 ;
  }
  // If found then select the text.
  if (position >= 0)
  {
    RichEdit1->SelStart = position ;
    RichEdit1->SelLength = dialog->FindText.Length () ;
  }
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ReplaceDialog1Replace(TObject *Sender)
{
  if (ReplaceDialog1->Options.Contains (frReplaceAll))
  {
    TSearchTypes options ;
    if (ReplaceDialog1->Options.Contains (frMatchCase))
      options << stMatchCase ;
    if (ReplaceDialog1->Options.Contains (frWholeWord))
      options << stWholeWord ;

    int position = RichEdit1->FindText (ReplaceDialog1->FindText, 0, -1, options) ;
    while (position >= 0)
    {
      RichEdit1->SelStart = position ;
      RichEdit1->SelLength = ReplaceDialog1->FindText.Length () ;
      RichEdit1->SelText = ReplaceDialog1->ReplaceText ;
      position = RichEdit1->FindText (ReplaceDialog1->FindText, 0, -1, options) ;
    }
  }
  else if (RichEdit1->SelLength > 0)
  {
    RichEdit1->SelText = ReplaceDialog1->ReplaceText ;
  }
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Replace1Click(TObject *Sender)
{
  ReplaceDialog1->Execute () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AlignLeftClick(TObject *Sender)
{
  RichEdit1->Paragraph->Alignment = taLeftJustify ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AlignCenterClick(TObject *Sender)
{
  RichEdit1->Paragraph->Alignment = taCenter ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AlignRightClick(TObject *Sender)
{
  RichEdit1->Paragraph->Alignment = taRightJustify ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Cut1Click(TObject *Sender)
{
  RichEdit1->CutToClipboard () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Copy1Click(TObject *Sender)
{
  RichEdit1->CopyToClipboard () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Paste1Click(TObject *Sender)
{
  RichEdit1->PasteFromClipboard () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SelectAll1Click(TObject *Sender)
{
  RichEdit1->SelStart = 0 ;
  RichEdit1->SelLength = -1 ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Edit1Click(TObject *Sender)
{
  if (SendMessage (RichEdit1->Handle, EM_CANUNDO, 0, 0))
    Undo1->Enabled = true ;
  else
    Undo1->Enabled = false ;

  if (RichEdit1->SelLength == 0)
  {
    Cut1->Enabled = false ;
    Copy1->Enabled = false ;
  }
  else
  {
    Cut1->Enabled = true ;
    Copy1->Enabled = true ;
  }
  if (Clipboard()->AsText.Length () == 0)
    Paste1->Enabled = false ;
  else
    Paste1->Enabled = true ;

  if (RichEdit1->Lines->Count == 0)
  {
    Find1->Enabled = false ;
    Replace1->Enabled = false ;
    FindNext1->Enabled = false ;
  }
  else
  {
    Find1->Enabled = true ;
    Replace1->Enabled = true ;
    if (lastsearchstring.Length () != 0)
      FindNext1->Enabled = true ;
    else
      FindNext1->Enabled = false ;
  }

  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Undo1Click(TObject *Sender)
{
  SendMessage (RichEdit1->Handle, EM_UNDO, 0, 0) ;
  return ;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
  AdjustPageWidth () ;
  return ;
}
//---------------------------------------------------------------------------
void TMainForm::UpdateStatusBar ()
{
  // Get the line number.
  int line = SendMessage (RichEdit1->Handle,
                          EM_LINEFROMCHAR,
                          RichEdit1->SelStart,
                          0) ;
  // Get the starting character position for the line.
  int lineindex = SendMessage (RichEdit1->Handle,
                               EM_LINEINDEX,
                               line,
                               0) ;
  StatusBar1->Panels->Items[0]->Text = String (line + 1) + ": "
                         + String (RichEdit1->SelStart - lineindex + 1);
  if (RichEdit1->Modified)
    StatusBar1->Panels->Items[1]->Text = "Modified" ;
  else
    StatusBar1->Panels->Items[1]->Text = "" ;

  if (filename != "")
    StatusBar1->Panels->Items [2]->Text = filename ;
  else
    StatusBar1->Panels->Items [2]->Text = "(Untitled)" ;

  return ;
}


void __fastcall TMainForm::PageWidth1Click(TObject *Sender)
{
  SetPageWidth->Edit1->Text = String (pagewidth) ;
  if (SetPageWidth->ShowModal ())
  {
    pagewidth = SetPageWidth->Edit1->Text.ToDouble () ;
    AdjustPageWidth () ;
  }
  return ;
}
//---------------------------------------------------------------------------
void TMainForm::AdjustPageWidth ()
{
  const gutter = 10 ;
  RECT rect = { gutter,
                gutter,
                (int) (pagewidth * (double) PixelsPerInch),
                RichEdit1->ClientHeight - 2 * gutter} ;
  SendMessage (RichEdit1->Handle, EM_SETRECT, 0, (LPARAM) &rect) ;
  return ;
}

void __fastcall TMainForm::ParagraphAttributes1Click(TObject *Sender)
{
  SetParagraph->Edit1->Text = String ((double) RichEdit1->Paragraph->FirstIndent / (double) PixelsPerInch) ;
  SetParagraph->Edit2->Text =
    String ((double) (RichEdit1->Paragraph->FirstIndent + RichEdit1->Paragraph->LeftIndent) / (double) PixelsPerInch) ;
  SetParagraph->Edit3->Text = String ((double) RichEdit1->Paragraph->RightIndent / (double) PixelsPerInch) ;
  if (SetParagraph->ShowModal ())
  {
    RichEdit1->Paragraph->FirstIndent = (int) (SetParagraph->Edit1->Text.ToDouble () * (double) PixelsPerInch) ;
    RichEdit1->Paragraph->LeftIndent = (int) (SetParagraph->Edit2->Text.ToDouble () * (double) PixelsPerInch) - RichEdit1->Paragraph->FirstIndent ;
    RichEdit1->Paragraph->RightIndent = (int) (SetParagraph->Edit3->Text.ToDouble () * (double) PixelsPerInch) ;
  }
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Ejecuta1Click(TObject *Sender)
{
//    system("ejecutor");
    spawnl(P_WAIT, "ejecutor.exe", "ejecutor.exe", NULL);
//    Fejecuta->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Traduce1Click(TObject *Sender)
{
    Ftraduce->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Construye1Click(TObject *Sender)
{
//    Fconstruye->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Estadisticas1Click(TObject *Sender)
{
// system("\\Archiv~1\\Micros~2\\Office\\excel");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Ejecuta2Click(TObject *Sender)
{
// AQUI VA TODO
//Ftraduce->ShowModal();
//Fconstruye->ShowModal();
//Fejecuta->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Editor1Click(TObject *Sender)
{
 Fedito->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Compile1Click(TObject *Sender)
{
FCompile1->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Generator1Click(TObject *Sender)
{
    Feditue->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Tree1Click(TObject *Sender)
{
FGenerator->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Marcher1Click(TObject *Sender)
{
    FcomAB->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Planificador1Click(TObject *Sender)
{
    Fplan->ShowModal();
}
//---------------------------------------------------------------------------

